check-lxdialog.sh 1.6 KB
Newer Older
1 2 3 4 5 6
#!/bin/sh
# Check ncurses compatibility

# What library to link
ldflags()
{
7 8 9 10 11 12 13 14 15
	for ext in so a dylib ; do
		for lib in ncursesw ncurses curses ; do
			$cc -print-file-name=lib${lib}.${ext} | grep -q /
			if [ $? -eq 0 ]; then
				echo "-l${lib}"
				exit
			fi
		done
	done
16
	exit 1
17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32
}

# Where is ncurses.h?
ccflags()
{
	if [ -f /usr/include/ncurses/ncurses.h ]; then
		echo '-I/usr/include/ncurses -DCURSES_LOC="<ncurses.h>"'
	elif [ -f /usr/include/ncurses/curses.h ]; then
		echo '-I/usr/include/ncurses -DCURSES_LOC="<ncurses/curses.h>"'
	elif [ -f /usr/include/ncurses.h ]; then
		echo '-DCURSES_LOC="<ncurses.h>"'
	else
		echo '-DCURSES_LOC="<curses.h>"'
	fi
}

S
Sam Ravnborg 已提交
33 34 35 36
# Temp file, try to clean up after us
tmp=.lxdialog.tmp
trap "rm -f $tmp" 0 1 2 3 15

37 38
# Check if we can link to ncurses
check() {
39 40 41 42
        $cc -xc - -o $tmp 2>/dev/null <<'EOF'
#include CURSES_LOC
main() {}
EOF
43
	if [ $? != 0 ]; then
44 45 46 47 48 49 50
	    echo " *** Unable to find the ncurses libraries or the"       1>&2
	    echo " *** required header files."                            1>&2
	    echo " *** 'make menuconfig' requires the ncurses libraries." 1>&2
	    echo " *** "                                                  1>&2
	    echo " *** Install ncurses (ncurses-devel) and try again."    1>&2
	    echo " *** "                                                  1>&2
	    exit 1
51 52 53 54 55 56 57
	fi
}

usage() {
	printf "Usage: $0 [-check compiler options|-header|-library]\n"
}

58
if [ $# -eq 0 ]; then
59 60 61 62
	usage
	exit 1
fi

S
Sam Ravnborg 已提交
63
cc=""
64 65 66
case "$1" in
	"-check")
		shift
67
		cc="$@"
68 69 70 71 72 73
		check
		;;
	"-ccflags")
		ccflags
		;;
	"-ldflags")
74 75
		shift
		cc="$@"
76 77 78 79 80 81 82
		ldflags
		;;
	"*")
		usage
		exit 1
		;;
esac